/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: e_bmsg.c,v 1.2 1997/09/25 17:15:49 ae59 Exp $ */
/*
$Log: e_bmsg.c,v $
 * Revision 1.2  1997/09/25  17:15:49  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:13  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : e_bmsg.c                              */
/*                                                              */
/*      Entries         : void e_bmsg(device)                   */
/*                        FILE *device;                         */
/*                                                              */
/*      Arguments       : device - output device for traceback  */
/*                                 message                      */
/*                                                              */
/*      Description     : print trace back message              */
/*                                                              */
/*      Date            : 1992-01-16                            */
/*      1992-01-16 : replace e_renv by o_text[6]                */
/*      1991-03-07 : display e_line only if e_line>0            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern bentry *e_btop;
extern char *e_head;
extern int e_line;
extern char *o_text[];
#endif

#ifdef LINT_ARGS
local void e_bmsg(FILE *device)
#else
local void e_bmsg(device)

FILE *device;
#endif
        {
        bentry *ent;

        if ((ent = e_btop)==(bentry *)NULL)
           {
           fprintf(device,"%se_bmsg : No items in trace back stack ",e_head);
           fprintf(device,"available.\n");
           return;
           }

        fprintf(device,"%sERROR",e_head);
        if (e_line>0) fprintf(device," at line %d",e_line);
#ifndef RTSTRC_DISABLE
        do
           {
           if (ent->filename==o_text[6])
              ent = ent->pred;
           else
              {
              if (ent->filename!=NULL)
                 fprintf(device," in '%s'",ent->filename);
              break;
              }
           }
        while (ent!=(bentry *)NULL);
#else
        if (ent->filename!=NULL)
           fprintf(device," in '%s'",ent->filename);
#endif
        fprintf(device,"\n");

        return;
        }

